package com.ibm.im.rdm.notifications;

import java.sql.Timestamp;
import java.util.Hashtable;

import javax.naming.Context;

import com.dwl.base.DWLControl;
import com.dwl.base.logging.DWLLoggerManager;
import com.dwl.base.logging.IDWLLogger;
import com.dwl.base.notification.CommonNotification;
import com.dwl.base.notification.NotificationLocal;
import com.dwl.base.notification.NotificationLocalHome;
import com.dwl.base.util.ServiceLocator;
import com.dwl.tcrm.common.TCRMControlKeys;
import com.dwl.tcrm.exception.TCRMException;

public class InvokeNotification {

	private static final IDWLLogger logger = DWLLoggerManager.getLogger(InvokeNotification.class);

	public void sendNotification(DWLControl control) throws Exception {

		logger.finest("## sendNotification start");
		MyCustomNotification myCustomNotification = new MyCustomNotification();


		//2.Setting the needed information to the notification object 
		myCustomNotification.setTxnType((String) control.get(DWLControl.REQUEST_NAME));
		myCustomNotification.setTxnTime(new Timestamp(System.currentTimeMillis()));
		myCustomNotification.setRequestId(control.get(DWLControl.REQUEST_ID).toString());
		myCustomNotification.setUserId((String) control.get(TCRMControlKeys.USER_NAME));

		//3. Set the preferred destination. This is an optional step.
		//myCustomNotification.addJMSDestination("jms/notification/topic/RDMDataSetChangeTopic");

		myCustomNotification.setControl(control);
		//5. Invoke the sendNotification method. Which intern invokes 
		//  the appropriate notify method.
		sendNotification(myCustomNotification);
		logger.finest("## sendNotification end");

	}

	protected final static NotificationLocalHome getNotificationLocalHome() throws Exception {

		ServiceLocator serviceLocator = ServiceLocator.getInstance();
		NotificationLocalHome home = (NotificationLocalHome) serviceLocator.getLocalHome("ejblocal:com/dwl/base/notification/NotificationLocal");

		//Hashtable env = new Hashtable();

		/*
		 * TODO check whether the next line can be removed. Should be the case because we pass credentials to the service.
		 */
		//env.put(Context.SECURITY_AUTHENTICATION, "none");
		//env.put(Context.SECURITY_PRINCIPAL, "tabs");
		//env.put(Context.SECURITY_CREDENTIALS, "tabs" );

		//NotificationLocalHome home = (NotificationLocalHome) ServiceLocator.getInstance().getLocalHome(
		//		"ejblocal:com/dwl/base/notification/NotificationLocal", env);

		return home;

	}
	public void sendNotification(CommonNotification theCommonNotification) throws Exception {

		NotificationLocal theNotificationBean = getNotificationLocalHome().create();
		theNotificationBean.notify(theCommonNotification);

	}

}
